package gregapi;

import static gregapi.data.CS.GAPI_POST;
import static gregapi.data.CS.T;
import gregapi.api.Abstract_Mod;
import gregapi.api.Abstract_Proxy;
import gregapi.data.CS.ModIDs;
import gregapi.data.CS.ModNames;
import gregapi.data.*;
import gregapi.load.LoaderItemData;
import gregapi.load.LoaderItemList;
import gregapi.oredict.OreDictManager;
import gregapi.recipes.GT_ModHandler;
import gregapi.util.OM;
import gregapi.util.UT;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.event.*;

/**
 * @author Gregorius Techneticies
 * 
 * This loads after the compatible Mods. The regular API loads before the compatible Mods.
 */
@Mod(modid=ModIDs.GAPI_POST, name=ModNames.GAPI_POST, version="GT6-MC1710", dependencies="required-after:"+ModIDs.GAPI+"; after:"+ModIDs.IC2+"; after:"+ModIDs.NC+"; after:"+ModIDs.CC+"; after:"+ModIDs.OC+"; after:"+ModIDs.FR+"; after:"+ModIDs.IE+"; after:"+ModIDs.UB+"; after:"+ModIDs.PFAA+"; after:"+ModIDs.TC+"; after:"+ModIDs.RC+"; after:"+ModIDs.AE+"; after:"+ModIDs.TE_CORE+"; after:"+ModIDs.TE+"; after:"+ModIDs.CHSL+"; after:"+ModIDs.TF+"; after:"+ModIDs.HaC+"; after:"+ModIDs.APC+"; after:"+ModIDs.ENVM+"; after:"+ModIDs.MaCr+"; after:"+ModIDs.BC_TRANSPORT+"; after:"+ModIDs.BC_SILICON+"; after:"+ModIDs.BC_FACTORY+"; after:"+ModIDs.BC_ENERGY+"; after:"+ModIDs.BC_CORE+"; after:"+ModIDs.BC_BUILDERS+"; after:"+ModIDs.MgC+"; after:"+ModIDs.ReC+"; after:"+ModIDs.RoC+"; after:"+ModIDs.GC_CORE+"; after:"+ModIDs.GC_MARS+"; after:"+ModIDs.GC_PLANETS+"; after:"+ModIDs.ATUM+"; after:ThermalExpansion|Transport; after:ThermalExpansion|Energy; after:ThermalExpansion|Factory; after:RedPowerCore; after:RedPowerBase; after:RedPowerMachine; after:RedPowerCompat; after:RedPowerWiring; after:RedPowerLogic; after:RedPowerLighting; after:RedPowerWorld; after:RedPowerControl;" /*after:ProjRed; after:ProjRed|Exploration; after:UndergroundBiomes; after:NetherOres; after:factorization; after:XyCraft; after:MetallurgyCore; after:MetallurgyBase; after:MetallurgyEnder; after:MetallurgyFantasy; after:MetallurgyNether; after:MetallurgyPrecious; after:MetallurgyUtility; after:BuildCraft|Silicon; after:BuildCraft|Core; after:BuildCraft|Transport; after:BuildCraft|Factory; after:BuildCraft|Energy; after:BuildCraft|Builders; before:TConstruct; before:TConstruct-Preloader; before:TMechworks; after:TwilightForest; after:Tubestuff; after:ICBM; after:Mekanism; after:MekanismGenerators; after:MekanismTools; after:ThaumicTinkerer; after:LiquidXP; after:MineFactoryReloaded; after:factorization.misc; after:AtomicScience; after:MFFS; after:ICBM|Contraption; after:ICBM|Explosion; after:ICBM|Sentry; after:mmmPowersuits;"*/)
public class GT_API_Post extends Abstract_Mod {
	public GT_API_Post() {GAPI_POST = this;}
	
	@Override public String getModID() {return ModIDs.GAPI_POST;}
	@Override public String getModName() {return ModNames.GAPI_POST;}
	@Override public String getModNameForLog() {return "GT_API_POST";}
	@Override public Abstract_Proxy getProxy() {return null;}
	
	@Mod.EventHandler public final void onPreLoad			(FMLPreInitializationEvent	aEvent) {GT_API.sAllowCrossModItemAccess = T; onModPreInit(aEvent);}
	@Mod.EventHandler public final void onLoad				(FMLInitializationEvent		aEvent) {onModInit(aEvent);}
	@Mod.EventHandler public final void onPostLoad			(FMLPostInitializationEvent	aEvent) {onModPostInit(aEvent);}
	@Mod.EventHandler public final void onServerStarting	(FMLServerStartingEvent		aEvent) {onModServerStarting(aEvent);}
	@Mod.EventHandler public final void onServerStarted		(FMLServerStartedEvent		aEvent) {onModServerStarted(aEvent);}
	@Mod.EventHandler public final void onServerStopping	(FMLServerStoppingEvent		aEvent) {onModServerStopping(aEvent);}
	@Mod.EventHandler public final void onServerStopped		(FMLServerStoppedEvent		aEvent) {onModServerStopped(aEvent);}
	
	@Override
	public void onModPreInit2(FMLPreInitializationEvent aEvent) {
		new LoaderItemList().run();
		new LoaderItemData().run();
		
		// Because most of those Mods (and vanilla MC) are not OreDict Compatible and need to be set as Target manually.
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.FierySteel			, GT_ModHandler.getModItem(ModIDs.TF, "item.fieryIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Knightmetal		, GT_ModHandler.getModItem(ModIDs.TF, "item.knightMetal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Steeleaf			, GT_ModHandler.getModItem(ModIDs.TF, "item.steeleafIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.IronWood			, GT_ModHandler.getModItem(ModIDs.TF, "item.ironwoodIngot", 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedAir			, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedFire		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 1));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedWater		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 2));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEarth		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 3));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedOrder		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 4));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEntropy		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Hg					, GT_ModHandler.getModItem(ModIDs.TC, "ItemNugget", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Thaumium			, GT_ModHandler.getModItem(ModIDs.TC, "ItemNugget", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.VoidMetal			, GT_ModHandler.getModItem(ModIDs.TC, "ItemNugget", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Thaumium			, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.VoidMetal			, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1,16));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Hg					, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Amber				, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Thaumium			, GT_ModHandler.getModItem(ModIDs.TC, "blockCosmeticSolid", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Firestone			, GT_ModHandler.getModItem(ModIDs.RC, "firestone.raw", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.CoalCoke			, GT_ModHandler.getModItem(ModIDs.RC, "fuel.coke", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.CoalCoke			, GT_ModHandler.getModItem(ModIDs.RC, "cube", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Fe					, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Steel				, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 1));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.TinAlloy			, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 2));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Cu					, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 3));
    	OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.TungstenCarbide	, GT_ModHandler.getModItem(ModIDs.MgC, "item.ingotCarbide", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.TungstenCarbide	, GT_ModHandler.getModItem(ModIDs.ReC, "reactorcraft_item_crafting", 1, 17));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Netherrack			, GT_ModHandler.getModItem(ModIDs.RoC, "rotarycraft_item_powders", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Nutmeg				, GT_ModHandler.getModItem(ModIDs.HaC, "groundnutmegItem", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cinnamon			, GT_ModHandler.getModItem(ModIDs.HaC, "groundcinnamonItem", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cocoa				, GT_ModHandler.getModItem(ModIDs.HaC, "cocoapowderItem", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxPlant			, GT_ModHandler.getModItem(ModIDs.HaC, "waxItem", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxBee				, GT_ModHandler.getModItem(ModIDs.HaC, "beeswaxItem", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxBee				, GT_ModHandler.getModItem(ModIDs.FR, "beeswax", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.WaxRefractory		, GT_ModHandler.getModItem(ModIDs.FR, "refractoryWax", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Pyrotheum			, GT_ModHandler.getModItem(ModIDs.TE_CORE, "material", 1, 512));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cryotheum			, GT_ModHandler.getModItem(ModIDs.TE_CORE, "material", 1, 513));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Coffee				, GT_ModHandler.getIC2Item("coffeePowder", 1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Empty				, IL.Cell_Empty.get(1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Lava				, IL.Cell_Lava.get(1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Water				, IL.Cell_Water.get(1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Creosote			, GT_ModHandler.getModItem(ModIDs.RC, "fluid.creosote.cell", 1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.UUMatter			, GT_ModHandler.getIC2Item("uuMatterCell", 1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.ConstructionFoam	, GT_ModHandler.getIC2Item("CFCell", 1));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Empty				, UT.Stacks.make(Items.bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Water				, UT.Stacks.make(Items.water_bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Lava				, UT.Stacks.make(Items.lava_bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Milk				, UT.Stacks.make(Items.milk_bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Empty				, UT.Stacks.make(Items.glass_bottle, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Water				, UT.Stacks.make(Items.potionitem, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.plateAlloy		, MT.Iridium			, GT_ModHandler.getIC2Item("iridiumPlate", 1));
    	OreDictManager.INSTANCE.setTarget(OP.plateAlloy		, MT.Advanced			, GT_ModHandler.getIC2Item("advancedAlloy", 1));
    	OreDictManager.INSTANCE.setTarget(OP.plateAlloy		, MT.C					, GT_ModHandler.getIC2Item("carbonPlate", 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Coal				, UT.Stacks.make(Blocks.coal_ore, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Fe					, UT.Stacks.make(Blocks.iron_ore, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Lapis				, UT.Stacks.make(Blocks.lapis_ore, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone			, UT.Stacks.make(Blocks.redstone_ore, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone			, UT.Stacks.make(Blocks.lit_redstone_ore, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Au					, UT.Stacks.make(Blocks.gold_ore, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Diamond			, UT.Stacks.make(Blocks.diamond_ore, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Emerald			, UT.Stacks.make(Blocks.emerald_ore, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.ore			, MT.NetherQuartz		, UT.Stacks.make(Blocks.quartz_ore, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Iridium			, GT_ModHandler.getIC2Item("iridiumOre", 1));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lapis				, UT.Stacks.make(Items.dye, 1, 4));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderEye			, UT.Stacks.make(Items.ender_eye, 1, 0));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderPearl			, UT.Stacks.make(Items.ender_pearl, 1, 0));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Diamond			, UT.Stacks.make(Items.diamond, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Emerald			, UT.Stacks.make(Items.emerald, 1, 0));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Coal				, UT.Stacks.make(Items.coal, 1, 0));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Charcoal			, UT.Stacks.make(Items.coal, 1, 1));
    	OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherQuartz		, UT.Stacks.make(Items.quartz, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherStar			, UT.Stacks.make(Items.nether_star, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Au					, UT.Stacks.make(Items.gold_nugget, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Au					, UT.Stacks.make(Items.gold_ingot, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Fe					, UT.Stacks.make(Items.iron_ingot, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Paper				, UT.Stacks.make(Items.paper, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Sugar				, UT.Stacks.make(Items.sugar, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Bone				, IL.Dye_Bonemeal.get(1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Redstone			, UT.Stacks.make(Items.redstone, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Gunpowder			, UT.Stacks.make(Items.gunpowder, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Glowstone			, UT.Stacks.make(Items.glowstone_dust, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Blaze				, UT.Stacks.make(Items.blaze_powder, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Blaze				, UT.Stacks.make(Items.blaze_rod, 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Wood				, UT.Stacks.make(Items.stick, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Fe					, UT.Stacks.make(Blocks.iron_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Au					, UT.Stacks.make(Blocks.gold_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Diamond			, UT.Stacks.make(Blocks.diamond_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Emerald			, UT.Stacks.make(Blocks.emerald_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Lapis				, UT.Stacks.make(Blocks.lapis_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Coal				, UT.Stacks.make(Blocks.coal_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockDust		, MT.Redstone			, UT.Stacks.make(Blocks.redstone_block, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Fe					, GT_ModHandler.getIC2Item("casingiron", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Au					, GT_ModHandler.getIC2Item("casinggold", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Cu					, GT_ModHandler.getIC2Item("casingcopper", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Sn					, GT_ModHandler.getIC2Item("casingtin", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Pb					, GT_ModHandler.getIC2Item("casinglead", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Bronze				, GT_ModHandler.getIC2Item("casingbronze", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Steel				, GT_ModHandler.getIC2Item("casingadviron", 1));
    	
		OM.blacklist(GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1,18));
	}
	
	@Override public void onModInit2(FMLInitializationEvent aEvent) {/**/}
	@Override public void onModPostInit2(FMLPostInitializationEvent aEvent) {/**/}
	@Override public void onModServerStarting2(FMLServerStartingEvent aEvent) {/**/}
	@Override public void onModServerStarted2(FMLServerStartedEvent aEvent) {/**/}
	@Override public void onModServerStopping2(FMLServerStoppingEvent aEvent) {/**/}
	@Override public void onModServerStopped2(FMLServerStoppedEvent aEvent) {/**/}
}