package gregapi;

import static gregapi.data.CS.*;
import gregapi.api.Abstract_Mod;
import gregapi.block.prefixblock.PrefixBlockFallingEntity;
import gregapi.code.ArrayListNoNulls;
import gregapi.cover.CoverRegistry;
import gregapi.cover.ICover;
import gregapi.data.CS.ModNames;
import gregapi.data.CS.ToolsGT;
import gregapi.data.*;
import gregapi.item.IItemGT;
import gregapi.lang.LanguageHandler;
import gregapi.log.GT_Log;
import gregapi.oredict.IOreDictListenerItem;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictMaterial;
import gregapi.oredict.OreDictMaterialStack;
import gregapi.render.ITexture;
import gregapi.render.RendererBlockTextured;
import gregapi.tileentity.render.ITileEntityOnDrawBlockHighlight;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.Arrays;
import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.entity.RenderFallingBlock;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.client.event.DrawBlockHighlightEvent;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;

import org.lwjgl.opengl.GL11;

import cpw.mods.fml.client.FMLClientHandler;
import cpw.mods.fml.client.registry.RenderingRegistry;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.TickEvent.ClientTickEvent;
import cpw.mods.fml.common.gameevent.TickEvent.Phase;

/**
 * @author Gregorius Techneticies
 */
public class GT_API_Proxy_Client extends GT_API_Proxy {
	public GT_API_Proxy_Client() {
		super();
		CODE_SERVER = T;
		CODE_CLIENT = T;
		
		for (int i = 0; i < 4; i++) {
			mPosR.addAll(Arrays.asList(MT.ChargedCertusQuartz.mRGBa[i], MT.Enderium.mRGBa[i], MT.Vinteum.mRGBa[i], MT.U_235.mRGBa[i], MT.InfusedGold.mRGBa[i], MT.Am_241.mRGBa[i], MT.Pu_241.mRGBa[i], MT.Pu_243.mRGBa[i], MT.Nq_528.mRGBa[i], MT.Nq_522.mRGBa[i], MT.InfusedOrder.mRGBa[i], MT.Force.mRGBa[i], MT.Pyrotheum.mRGBa[i], MT.Sunnarium.mRGBa[i], MT.Glowstone.mRGBa[i], MT.Thaumium.mRGBa[i], MT.InfusedVis.mRGBa[i], MT.InfusedAir.mRGBa[i], MT.InfusedFire.mRGBa[i], MT.FierySteel.mRGBa[i], MT.Firestone.mRGBa[i]));
			mPosG.addAll(Arrays.asList(MT.ChargedCertusQuartz.mRGBa[i], MT.Enderium.mRGBa[i], MT.Vinteum.mRGBa[i], MT.U_235.mRGBa[i], MT.InfusedGold.mRGBa[i], MT.Am_241.mRGBa[i], MT.Pu_241.mRGBa[i], MT.Pu_243.mRGBa[i], MT.Nq_528.mRGBa[i], MT.Nq_522.mRGBa[i], MT.InfusedOrder.mRGBa[i], MT.Force.mRGBa[i], MT.Pyrotheum.mRGBa[i], MT.Sunnarium.mRGBa[i], MT.Glowstone.mRGBa[i], MT.InfusedAir.mRGBa[i], MT.InfusedEarth.mRGBa[i]));
			mPosB.addAll(Arrays.asList(MT.ChargedCertusQuartz.mRGBa[i], MT.Enderium.mRGBa[i], MT.Vinteum.mRGBa[i], MT.U_235.mRGBa[i], MT.InfusedGold.mRGBa[i], MT.Am_241.mRGBa[i], MT.Pu_241.mRGBa[i], MT.Pu_243.mRGBa[i], MT.Nq_528.mRGBa[i], MT.Nq_522.mRGBa[i], MT.InfusedOrder.mRGBa[i], MT.InfusedVis.mRGBa[i], MT.InfusedWater.mRGBa[i], MT.Thaumium.mRGBa[i], MT.Co_60.mRGBa[i], MT.Lumium.mRGBa[i]));
			mNegR.addAll(Arrays.asList(MT.InfusedEntropy.mRGBa[i], MT.NetherStar.mRGBa[i]));
			mNegG.addAll(Arrays.asList(MT.InfusedEntropy.mRGBa[i], MT.NetherStar.mRGBa[i]));
			mNegB.addAll(Arrays.asList(MT.InfusedEntropy.mRGBa[i], MT.NetherStar.mRGBa[i]));
		}
	}
	
	@Override
	public EntityPlayer getThePlayer() {
		return Minecraft.getMinecraft().thePlayer;
	}
	
	@Override
	public void onProxyAfterPreInit(Abstract_Mod aMod, FMLPreInitializationEvent aEvent) {
		RenderingRegistry.registerEntityRenderingHandler(PrefixBlockFallingEntity.class, new RenderFallingBlock());
		RenderingRegistry.registerBlockHandler(new RendererBlockTextured(RenderingRegistry.getNextAvailableRenderId()));
    	// Check if OptiFine is loaded in order to disable some GT Render Hooks to fix Glitches.
    	ITexture.Util.OPTIFINE_LOADED = FMLClientHandler.instance().hasOptifine();
	}
	
	@Override
	public void onProxyBeforeInit(Abstract_Mod aMod, FMLInitializationEvent aEvent) {
		for (OreDictMaterial tMaterial : OreDictMaterial.MATERIAL_MAP.values()) LanguageHandler.add("gt.material." + tMaterial.mNameInternal, tMaterial.mNameLocal);
	}
	
	public final List<short[]> mPosR = new ArrayListNoNulls<short[]>(), mPosG = new ArrayListNoNulls<short[]>(), mPosB = new ArrayListNoNulls<short[]>(), mPosA = new ArrayListNoNulls<short[]>(), mNegR = new ArrayListNoNulls<short[]>(), mNegG = new ArrayListNoNulls<short[]>(), mNegB = new ArrayListNoNulls<short[]>(), mNegA = new ArrayListNoNulls<short[]>();
	private long mAnimationTick = 0;
	private boolean mAnimationDirection = T;
	
	@SubscribeEvent
    public void onItemTooltip(ItemTooltipEvent aEvent) {
		if (!GAPI_POST.mFinishedPostInit) return;
		
		ICover tCover = CoverRegistry.get(aEvent.itemStack);
		if (tCover != null) tCover.addToolTips(aEvent.toolTip, aEvent.itemStack, aEvent.showAdvancedItemTooltips);
		
		OreDictItemData tData = OM.anydata(aEvent.itemStack);
		if (tData != null) {
			if (tData.mPrefix != null) {
				for (IOreDictListenerItem tListener : tData.mPrefix.mListenersItem) {
					String tToolTip = tListener.getListenerToolTip(aEvent.itemStack);
					if (tToolTip != null) aEvent.toolTip.add(tToolTip);
				}
			}
			for (OreDictMaterialStack tMaterial : tData.getAllMaterialStacks()) {
				for (IOreDictListenerItem tListener : tMaterial.mMaterial.mListenersItem) {
					String tToolTip = tListener.getListenerToolTip(aEvent.itemStack);
					if (tToolTip != null) aEvent.toolTip.add(tToolTip);
				}
			}
			
			if (tData.mPrefix != null && tData.mMaterial != null) {
				if (tData.mMaterial.mMaterial.contains(TD.Properties.HAS_TOOL_STATS)) {
					aEvent.toolTip.add(LH.Chat.BLUE + "Q: " + tData.mMaterial.mMaterial.mToolQuality + " - S: " + tData.mMaterial.mMaterial.mToolSpeed + " - D: " + tData.mMaterial.mMaterial.mToolDurability);
				}
				if (tData.mMaterial.mMaterial.mEnchantmentTools != null || tData.mMaterial.mMaterial.mEnchantmentArmors != null) {
					aEvent.toolTip.add(LH.Chat.PURPLE + "Possible Enchantments:");
					if (tData.mMaterial.mMaterial.mEnchantmentTools != null) {
						aEvent.toolTip.add(LH.Chat.PINK + tData.mMaterial.mMaterial.mEnchantmentTools.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel));
						if (tData.mMaterial.mMaterial.mEnchantmentTools == Enchantment.fortune		) aEvent.toolTip.add(LH.Chat.PINK + Enchantment.looting	.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel)); else
						if (tData.mMaterial.mMaterial.mEnchantmentTools == Enchantment.knockback	) aEvent.toolTip.add(LH.Chat.PINK + Enchantment.punch	.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel)); else
						if (tData.mMaterial.mMaterial.mEnchantmentTools == Enchantment.fireAspect	) aEvent.toolTip.add(LH.Chat.PINK + Enchantment.flame	.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel));
					}
					if (tData.mMaterial.mMaterial.mEnchantmentArmors != null && tData.mMaterial.mMaterial.mEnchantmentArmors != tData.mMaterial.mMaterial.mEnchantmentTools) {
						aEvent.toolTip.add(LH.Chat.PINK + tData.mMaterial.mMaterial.mEnchantmentArmors.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentArmorsLevel));
					}
				}
				if (tData.mMaterial.mMaterial.contains(TD.Properties.FLAMMABLE)) {
					if (tData.mMaterial.mMaterial.contains(TD.Properties.EXPLOSIVE)) {
						aEvent.toolTip.add(LH.Chat.RED + "Flammable and Explosive!");
					} else {
						aEvent.toolTip.add(LH.Chat.RED + "Flammable!");
					}
				} else if (tData.mMaterial.mMaterial.contains(TD.Properties.EXPLOSIVE)) {
					aEvent.toolTip.add(LH.Chat.RED + "Explosive!");
				}
				if (aEvent.itemStack.getItem() instanceof IItemGT) {
					if (UT.Code.stringValid(tData.mMaterial.mMaterial.mOriginalMod)) {
						if (tData.mMaterial.mMaterial.mOriginalMod.equals(ModNames.MC)) {
							aEvent.toolTip.add(LH.Chat.BLUE + "Mod: None (Vanilla Material)");
						} else {
							aEvent.toolTip.add(LH.Chat.BLUE + "Mod: " + tData.mMaterial.mMaterial.mOriginalMod);
						}
					} else {
						aEvent.toolTip.add(LH.Chat.BLUE + "Mod: Unknown (But definetly not GregTech)");
					}
				}
			}
			if (aEvent.showAdvancedItemTooltips) {
				for (OreDictMaterialStack tMaterial : tData.getAllMaterialStacks()) if (!tMaterial.mMaterial.contains(TD.Properties.DONT_SHOW_THIS_COMPONENT)) {
					if (tMaterial.mAmount > 0) {
						int tDigits = (int)(((tMaterial.mAmount % U) / UD) * 1000);
						aEvent.toolTip.add("Contains " + (tMaterial.mAmount / U) + "." + (tDigits<1?"000":tDigits<10?"00"+tDigits:tDigits<100?"0"+tDigits:tDigits) + " Units of " + tMaterial.mMaterial.getLocal());
					} else if (tMaterial.mAmount < 0) {
						aEvent.toolTip.add("Contains an unknown Amount of " + tMaterial.mMaterial.getLocal());
					}
					double tWeight = tMaterial.mAmount > 0 ? tMaterial.mMaterial.getWeight(tMaterial.mAmount) : 0;
					aEvent.toolTip.add("Melt: " + tMaterial.mMaterial.mMeltingPoint + " K - Boil: " + tMaterial.mMaterial.mBoilingPoint + " K"+(tWeight>0?" - Weight: " + (long)tWeight + "." + (((long)(tWeight*1000))%1000) + " kg":""));
				}
			}
		}
		
		if (UT.NBT.getNBT(aEvent.itemStack).getBoolean("gt.err.oredict.output")) {
			aEvent.toolTip.add(0, "A Recipe used an OreDict Item as Output directly, without copying it before!");
			aEvent.toolTip.add(1, "This is a typical CallByReference/CallByValue Error of the Modder doing it.");
			aEvent.toolTip.add(2, "Please check all Recipes outputting this Item, and report the Recipes to their Owner.");
			aEvent.toolTip.add(3, "The Owner of the RECIPE, NOT the Owner of the Item!");
		}
    }
    
	@SubscribeEvent
	public void onClientTickEvent(ClientTickEvent aEvent) {
		if (aEvent.phase == Phase.END) {
	    	mAnimationTick++;
			if (mAnimationTick%50 == 0) mAnimationDirection = !mAnimationDirection;
			
			int tDirection = mAnimationDirection?+1:-1;
			for (short[] tArray : mPosR) {tArray[0]+=tDirection; tArray[0] = UT.Code.bindByte(tArray[0]);}
			for (short[] tArray : mPosG) {tArray[1]+=tDirection; tArray[1] = UT.Code.bindByte(tArray[1]);}
			for (short[] tArray : mPosB) {tArray[2]+=tDirection; tArray[2] = UT.Code.bindByte(tArray[2]);}
			for (short[] tArray : mPosA) {tArray[3]+=tDirection; tArray[3] = UT.Code.bindByte(tArray[3]);}
			for (short[] tArray : mNegR) {tArray[0]-=tDirection; tArray[0] = UT.Code.bindByte(tArray[0]);}
			for (short[] tArray : mNegG) {tArray[1]-=tDirection; tArray[1] = UT.Code.bindByte(tArray[1]);}
			for (short[] tArray : mNegB) {tArray[2]-=tDirection; tArray[2] = UT.Code.bindByte(tArray[2]);}
			for (short[] tArray : mNegA) {tArray[3]-=tDirection; tArray[3] = UT.Code.bindByte(tArray[3]);}
		}
	}
	
	@SubscribeEvent
	public void onDrawBlockHighlight(DrawBlockHighlightEvent aEvent) {
		if (UT.Stacks.valid(aEvent.currentItem)) {
			Block aBlock = aEvent.player.worldObj.getBlock(aEvent.target.blockX, aEvent.target.blockY, aEvent.target.blockZ);
			TileEntity aTileEntity = UT.Worlds.getTileEntity(aEvent.player.worldObj, aEvent.target.blockX, aEvent.target.blockY, aEvent.target.blockZ, T);
			if (!(aTileEntity instanceof ITileEntityOnDrawBlockHighlight) || !((ITileEntityOnDrawBlockHighlight)aTileEntity).onDrawBlockHighlight(aEvent)) {
				if ((ROTATABLE_VANILLA_BLOCKS.contains(aBlock) || aTileEntity instanceof ic2.api.tile.IWrenchable) && ToolsGT.contains(TOOL_wrench, aEvent.currentItem)) {
					drawGrid(aEvent);
					return;
				}
			}
		}
	}
	
	private static List<Block> ROTATABLE_VANILLA_BLOCKS = Arrays.asList(Blocks.piston, Blocks.sticky_piston, Blocks.furnace, Blocks.lit_furnace, Blocks.dropper, Blocks.dispenser, Blocks.chest, Blocks.trapped_chest, Blocks.ender_chest, Blocks.hopper, Blocks.pumpkin, Blocks.lit_pumpkin);
	
	private static void drawGrid(DrawBlockHighlightEvent aEvent) {
		try {
			Class.forName("codechicken.lib.vec.Rotation");
			GL11.glPushMatrix();
			GL11.glTranslated(-(aEvent.player.lastTickPosX + (aEvent.player.posX - aEvent.player.lastTickPosX) * aEvent.partialTicks), -(aEvent.player.lastTickPosY + (aEvent.player.posY - aEvent.player.lastTickPosY) * aEvent.partialTicks), -(aEvent.player.lastTickPosZ + (aEvent.player.posZ - aEvent.player.lastTickPosZ) * aEvent.partialTicks));
			GL11.glTranslated(aEvent.target.blockX + 0.5F, aEvent.target.blockY + 0.5F, aEvent.target.blockZ + 0.5F);
			codechicken.lib.vec.Rotation.sideRotations[aEvent.target.sideHit].glApply();
			GL11.glTranslated(0, -0.501, 0);
			GL11.glLineWidth(2.0F);
			GL11.glColor4f(0, 0, 0, 0.5F);
			GL11.glBegin(GL11.GL_LINES);
			GL11.glVertex3d( 0.50, 0, -0.25);
			GL11.glVertex3d(-0.50, 0, -0.25);
			GL11.glVertex3d( 0.50, 0,  0.25);
			GL11.glVertex3d(-0.50, 0,  0.25);
			GL11.glVertex3d( 0.25, 0, -0.50);
			GL11.glVertex3d( 0.25, 0,  0.50);
			GL11.glVertex3d(-0.25, 0, -0.50);
			GL11.glVertex3d(-0.25, 0,  0.50);
			GL11.glEnd();
			GL11.glPopMatrix();
		} catch(Throwable e) {
			if (D1) e.printStackTrace(GT_Log.err);
		}
	}
}