package gregapi.load;

import static gregapi.data.CS.U;
import static gregapi.data.CS.W;
import gregapi.data.CS.ModIDs;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.recipes.GT_ModHandler;
import gregapi.util.OM;
import gregapi.util.UT;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 * 
 * Loads the ItemData for several Items.
 * This happens during the InitPhase, or if GregTech is installed within the PreInitPhase, since GregTech loads after all the Mods mentioned here, unlike the API.
 */
public class LoaderItemData implements Runnable {
	@Override public String toString() {return "Item Data Loader";}
	
	@Override
	public void run() {
		OM.reg("cropApple"				, UT.Stacks.make(Items.apple, 1, 0));
    	OM.reg("cropMelon"				, UT.Stacks.make(Items.melon, 1, 0));
    	OM.reg("cropPumpkin"			, UT.Stacks.make(Blocks.pumpkin, 1, 0));
    	OM.reg("cropCarrot"				, UT.Stacks.make(Items.carrot, 1, 0));
    	OM.reg("cropWheat"				, UT.Stacks.make(Items.wheat, 1, 0));
    	OM.reg("cropCocoa"				, UT.Stacks.make(Items.dye, 1, 3));
    	OM.reg("cropPotato"				, UT.Stacks.make(Items.potato, 1, 0));
    	OM.reg("cropHops"				, GT_ModHandler.getIC2Item("hops", 1));
    	OM.reg("cropCoffee"				, GT_ModHandler.getIC2Item("coffeeBeans", 1));
    	OM.reg("cropLemon"				, GT_ModHandler.getModItem(ModIDs.FR, "fruits", 1, 3));
        OM.reg("cropChilipepper"		, GT_ModHandler.getModItem(ModIDs.MaCr, "magicalcrops_CropProduce", 1, 2));
        OM.reg("cropTomato"				, GT_ModHandler.getModItem(ModIDs.MaCr, "magicalcrops_CropProduce", 1, 8));
        OM.reg("cropGrape"				, GT_ModHandler.getModItem(ModIDs.MaCr, "magicalcrops_CropProduce", 1, 4));
        OM.reg("cropTea"				, GT_ModHandler.getModItem(ModIDs.GaSu, "teaLeaves", 1, 0));
    	OM.reg("listAllegg"				, UT.Stacks.make(Items.egg, 1, 0));
        OM.reg("listAllhydraraw"		, GT_ModHandler.getModItem(ModIDs.TF, "item.hydraChop", 1, 0));
        OM.reg("listAllvenisonraw"		, GT_ModHandler.getModItem(ModIDs.TF, "item.venisonRaw", 1, 0));
        OM.reg("listAllvenisoncooked"	, GT_ModHandler.getModItem(ModIDs.TF, "item.venisonCooked", 1, 0));
        OM.reg("listAllbeefraw"			, GT_ModHandler.getModItem(ModIDs.TF, "item.meefRaw", 1, 0));
        OM.reg("listAllbeefcooked"		, GT_ModHandler.getModItem(ModIDs.TF, "item.meefSteak", 1, 0));
        OM.reg("listAllbeefraw"			, UT.Stacks.make(Items.beef, 1, 0));
        OM.reg("listAllbeefcooked"		, UT.Stacks.make(Items.cooked_beef, 1, 0));
        OM.reg("listAllporkraw"			, UT.Stacks.make(Items.porkchop, 1, 0));
        OM.reg("listAllporkcooked"		, UT.Stacks.make(Items.cooked_porkchop, 1, 0));
        OM.reg("listAllchickenraw"		, UT.Stacks.make(Items.chicken, 1, 0));
        OM.reg("listAllchickencooked"	, UT.Stacks.make(Items.cooked_chicken, 1, 0));
    	OM.reg("listAllfishraw"			, UT.Stacks.make(Items.fish, 1, 0));
    	OM.reg("listAllfishraw"			, UT.Stacks.make(Items.fish, 1, 1));
    	OM.reg("listAllfishraw"			, UT.Stacks.make(Items.fish, 1, 2));
    	OM.reg("listAllfishraw"			, UT.Stacks.make(Items.fish, 1, 3));
    	OM.reg("listAllfishcooked"		, UT.Stacks.make(Items.cooked_fished, 1, 0));
    	OM.reg("listAllfishcooked"		, UT.Stacks.make(Items.cooked_fished, 1, 1));
    	
		for (ItemStack tItem : new ItemStack[] {GT_ModHandler.getModItem(ModIDs.TF, "item.meefRaw", 1, 0), GT_ModHandler.getModItem(ModIDs.TF, "item.venisonRaw", 1, 0), UT.Stacks.make(Items.porkchop, 1, 0), UT.Stacks.make(Items.beef, 1, 0), UT.Stacks.make(Items.chicken, 1, 0), UT.Stacks.make(Items.fish, 1, 0)}) if (tItem != null) {
			OM.data(UT.Stacks.copyMeta(W, tItem)											, MT.MeatRaw			,  U * 2 , MT.Bone, U / 9);
		}
		for (ItemStack tItem : new ItemStack[] {GT_ModHandler.getModItem(ModIDs.TF, "item.meefSteak", 1, 0), GT_ModHandler.getModItem(ModIDs.TF, "item.venisonCooked", 1, 0), UT.Stacks.make(Items.cooked_porkchop, 1, 0), UT.Stacks.make(Items.cooked_beef, 1, 0), UT.Stacks.make(Items.cooked_chicken, 1, 0), UT.Stacks.make(Items.cooked_fished, 1, 0)}) if (tItem != null) {
			OM.data(UT.Stacks.copyMeta(W, tItem)											, MT.MeatCooked			,  U * 2 , MT.Bone, U / 9);
		}
		
        OM.data(GT_ModHandler.getModItem(ModIDs.BC_CORE, "woodenGearItem"	, 1,   0)		, MT.Wood				,  U * 2);
        OM.data(GT_ModHandler.getModItem(ModIDs.BC_CORE, "stoneGearItem"	, 1,   0)		, MT.Wood				,  U * 2, MT.Stone				,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.BC_CORE, "ironGearItem"		, 1,   0)		, MT.Stone				,  U * 4, MT.TECH.AnyIron		,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.BC_CORE, "goldGearItem"		, 1,   0)		, MT.TECH.AnyIron		,  U * 4, MT.Au					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.BC_CORE, "diamondGearItem"	, 1,   0)		, MT.Au					,  U * 4, MT.Diamond			,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.FR, "gearTin"				, 1,   0)		, MT.Stone				,  U * 4, MT.Sn					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.FR, "gearCopper"			, 1,   0)		, MT.Stone				,  U * 4, MT.TECH.AnyCopper		,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.FR, "gearBronze"			, 1,   0)		, MT.Stone				,  U * 4, MT.Bronze				,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1,  12)		, MT.TECH.AnyIron		,  U * 5);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1,  13)		, MT.TECH.AnyIron		,  U * 1, MT.Au					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 128)		, MT.TECH.AnyIron		,  U * 1, MT.TECH.AnyCopper		,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 129)		, MT.TECH.AnyIron		,  U * 1, MT.Sn					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 130)		, MT.TECH.AnyIron		,  U * 1, MT.Ag					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 131)		, MT.TECH.AnyIron		,  U * 1, MT.Pb					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 132)		, MT.TECH.AnyIron		,  U * 1, MT.Ni					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 133)		, MT.TECH.AnyIron		,  U * 1, MT.Pt					,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 134)		, MT.TECH.AnyIron		,  U * 1, MT.Mithril			,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 135)		, MT.TECH.AnyIron		,  U * 1, MT.Electrum			,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 136)		, MT.TECH.AnyIron		,  U * 1, MT.Invar				,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 137)		, MT.TECH.AnyIron		,  U * 1, MT.Bronze				,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 138)		, MT.TECH.AnyIron		,  U * 1, MT.Signalum			,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 139)		, MT.TECH.AnyIron		,  U * 1, MT.Lumium				,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TE_CORE, "material"			, 1, 140)		, MT.TECH.AnyIron		,  U * 1, MT.Enderium			,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "part.gear"				, 1,   3)		, MT.Sn					,  U * 2);
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "part.gear"				, 1,   0)		, MT.Sn					,  U * 2, MT.Au					,  4*U/9);
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "part.gear"				, 1,   1)		, MT.Sn					,  U * 2, MT.TECH.AnyIron		,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "part.gear"				, 1,   2)		, MT.Sn					,  U * 2, MT.TECH.AnyIronSteel	,  U * 4);
		OM.dat2(UT.Stacks.make(Items.wooden_sword, 1, 0)									, MT.Wood				,  U * 2 + U / 2);
        OM.dat2(UT.Stacks.make(Items.wooden_pickaxe, 1, 0)									, MT.Wood				,  U * 3 + U    );
		OM.dat2(UT.Stacks.make(Items.wooden_shovel, 1, 0)									, MT.Wood				,  U * 1 + U    );
		OM.dat2(UT.Stacks.make(Items.wooden_axe, 1, 0)										, MT.Wood				,  U * 3 + U    );
		OM.dat2(UT.Stacks.make(Items.wooden_hoe, 1, 0)										, MT.Wood				,  U * 2 + U    );
		OM.dat2(UT.Stacks.make(Items.stone_sword, 1, 0)										, MT.Stone				,  U * 2, MT.Wood, U / 2);
        OM.dat2(UT.Stacks.make(Items.stone_pickaxe, 1, 0)									, MT.Stone				,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.stone_shovel, 1, 0)									, MT.Stone				,  U * 1, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.stone_axe, 1, 0)										, MT.Stone				,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.stone_hoe, 1, 0)										, MT.Stone				,  U * 2, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.iron_sword, 1, 0)										, MT.TECH.AnyIron		,  U * 2, MT.Wood, U / 2);
        OM.dat2(UT.Stacks.make(Items.iron_pickaxe, 1, 0)									, MT.TECH.AnyIron		,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.iron_shovel, 1, 0)										, MT.TECH.AnyIron		,  U * 1, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.iron_axe, 1, 0)										, MT.TECH.AnyIron		,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.iron_hoe, 1, 0)										, MT.TECH.AnyIron		,  U * 2, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.golden_sword, 1, 0)									, MT.Au					,  U * 2, MT.Wood, U / 2);
        OM.dat2(UT.Stacks.make(Items.golden_pickaxe, 1, 0)									, MT.Au					,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.golden_shovel, 1, 0)									, MT.Au					,  U * 1, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.golden_axe, 1, 0)										, MT.Au					,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.golden_hoe, 1, 0)										, MT.Au					,  U * 2, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.diamond_sword, 1, 0)									, MT.Diamond			,  U * 2, MT.Wood, U / 2);
        OM.dat2(UT.Stacks.make(Items.diamond_pickaxe, 1, 0)									, MT.Diamond			,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.diamond_shovel, 1, 0)									, MT.Diamond			,  U * 1, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.diamond_axe, 1, 0)										, MT.Diamond			,  U * 3, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.diamond_hoe, 1, 0)										, MT.Diamond			,  U * 2, MT.Wood, U    );
		OM.dat2(UT.Stacks.make(Items.leather_helmet, 1, 0)									, MT.UNUSED.Leather		,  U * 5);
		OM.dat2(UT.Stacks.make(Items.leather_chestplate, 1, 0)								, MT.UNUSED.Leather		,  U * 8);
		OM.dat2(UT.Stacks.make(Items.leather_leggings, 1, 0)								, MT.UNUSED.Leather		,  U * 7);
		OM.dat2(UT.Stacks.make(Items.leather_boots, 1, 0)									, MT.UNUSED.Leather		,  U * 4);
		OM.dat2(UT.Stacks.make(Items.chainmail_helmet, 1, 0)								, MT.TECH.AnyIronSteel	,  5*U/4);
		OM.dat2(UT.Stacks.make(Items.chainmail_chestplate, 1, 0)							, MT.TECH.AnyIronSteel	,  8*U/4);
		OM.dat2(UT.Stacks.make(Items.chainmail_leggings, 1, 0)								, MT.TECH.AnyIronSteel	,  7*U/4);
		OM.dat2(UT.Stacks.make(Items.chainmail_boots, 1, 0)									, MT.TECH.AnyIronSteel	,  4*U/4);
		OM.dat2(UT.Stacks.make(Items.iron_helmet, 1, 0)										, MT.TECH.AnyIron		,  U * 5);
		OM.dat2(UT.Stacks.make(Items.iron_chestplate, 1, 0)									, MT.TECH.AnyIron		,  U * 8);
		OM.dat2(UT.Stacks.make(Items.iron_leggings, 1, 0)									, MT.TECH.AnyIron		,  U * 7);
		OM.dat2(UT.Stacks.make(Items.iron_boots, 1, 0)										, MT.TECH.AnyIron		,  U * 4);
		OM.dat2(UT.Stacks.make(Items.golden_helmet, 1, 0)									, MT.Au					,  U * 5);
		OM.dat2(UT.Stacks.make(Items.golden_chestplate, 1, 0)								, MT.Au					,  U * 8);
		OM.dat2(UT.Stacks.make(Items.golden_leggings, 1, 0)									, MT.Au					,  U * 7);
		OM.dat2(UT.Stacks.make(Items.golden_boots, 1, 0)									, MT.Au					,  U * 4);
		OM.dat2(UT.Stacks.make(Items.diamond_helmet, 1, 0)									, MT.Diamond			,  U * 5);
		OM.dat2(UT.Stacks.make(Items.diamond_chestplate, 1, 0)								, MT.Diamond			,  U * 8);
		OM.dat2(UT.Stacks.make(Items.diamond_leggings, 1, 0)								, MT.Diamond			,  U * 7);
		OM.dat2(UT.Stacks.make(Items.diamond_boots, 1, 0)									, MT.Diamond			,  U * 4);
		OM.dat2(UT.Stacks.make(Items.shears, 1, 0)											, MT.TECH.AnyIron		,  U * 2);
		OM.dat2(GT_ModHandler.getModItem(ModIDs.TF, "item.giantPick", 1, 0)					, MT.Stone				,  U*192, MT.Wood, U*128);
        OM.dat2(GT_ModHandler.getModItem(ModIDs.TF, "item.giantSword", 1, 0)				, MT.Stone				,  U*128, MT.Wood, U* 64);
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "tile.GiantLog", 1, W)					, MT.Wood				,  U *64);
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "tile.GiantCobble", 1, W)				, MT.Stone				,  U *64);
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "tile.GiantObsidian", 1, W)				, MT.Obsidian			,  U *64);
        OM.dat2(GT_ModHandler.getModItem(ModIDs.TF, "item.minotaurAxe", 1, 0)				, MT.Diamond			,  U * 4, MT.Wood, OP.stick.mAmount * 2);
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.armorShards", 1, 0)				, MT.Knightmetal		,  U / 9);
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.shardCluster", 1, 0)				, MT.Knightmetal		,  U * 1);
    	OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.hydraChop", 1, W)					, MT.MeatRaw			,  U * 4);
		OM.data(GT_ModHandler.getModItem(ModIDs.AE, "item.ItemMultiMaterial", 1, 10)		, MT.CertusQuartz		,  U / 2);
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "item.ItemMultiMaterial", 1, 11)		, MT.NetherQuartz		,  U / 2);
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "item.ItemMultiMaterial", 1, 12)		, MT.UNUSED.Fluix		,  U / 2);
        OM.data(UT.Stacks.make(Blocks.quartz_block, 1, W)									, MT.NetherQuartz		,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "tile.BlockQuartz"			, 1, W)		, MT.CertusQuartz		,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "tile.BlockQuartzPillar"	, 1, W)		, MT.CertusQuartz		,  U * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "tile.BlockQuartzChiseled"	, 1, W)		, MT.CertusQuartz		,  U * 4);
        OM.data(UT.Stacks.make(Items.wheat_seeds, 1, W)										, MT.Wheat				,  U / 9);
        OM.data(UT.Stacks.make(Blocks.hay_block, 1, W)										, MT.Wheat				,  U * 9);
        OM.data(UT.Stacks.make(Items.snowball, 1, W)										, MT.Snow				,  U / 4);
        OM.data(UT.Stacks.make(Blocks.snow, 1, W)											, MT.Snow				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.glowstone, 1, W)										, MT.Glowstone			,  U * 4);
        OM.data(UT.Stacks.make(Blocks.redstone_lamp, 1, W)									, MT.Glowstone			,  U * 4, MT.Redstone, OP.dust.mAmount * 4);
        OM.data(UT.Stacks.make(Blocks.lit_redstone_lamp, 1, W)								, MT.Glowstone			,  U * 4, MT.Redstone, OP.dust.mAmount * 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.UB, "fossilPiece", 1, W)					, MT.Bone				,  U * 1);
        OM.data(GT_ModHandler.getModItem(ModIDs.FR, "craftingMaterial", 1, 5)				, MT.Ice				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.ice, 1, W)											, MT.Ice				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.packed_ice, 1, W)										, MT.Ice				,  U * 2);
        OM.data(UT.Stacks.make(Items.clay_ball					, 1, W)						, MT.Clay				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.clay						, 1, W)						, MT.Clay				,  U * 2);
        OM.data(UT.Stacks.make(Blocks.hardened_clay				, 1, W)						, MT.Clay				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stained_hardened_clay		, 1, W)						, MT.Clay				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.brick_block				, 1, W)						, MT.Clay				,  U * 1);
        OM.data(UT.Stacks.make(Items.brick						, 1, W)						, MT.Clay				,  U / 4);
        OM.data(UT.Stacks.make(Items.firework_charge			, 1, W)						, MT.Gunpowder			,  U * 1);
        OM.data(UT.Stacks.make(Items.fireworks					, 1, W)						, MT.Gunpowder			,  U * 1);
        OM.data(GT_ModHandler.getIC2Item("Uran238", 1)										, MT.U_238				,  U * 1);
        OM.data(GT_ModHandler.getIC2Item("Uran235", 1)										, MT.U_235				,  U * 1);
        OM.data(GT_ModHandler.getIC2Item("Plutonium", 1)									, MT.Pu					,  U * 1);
        OM.data(GT_ModHandler.getIC2Item("smallUran235", 1)									, MT.U_235				,  U / 9);
        OM.data(GT_ModHandler.getIC2Item("smallPlutonium", 1)								, MT.Pu					,  U / 9);
        OM.data(GT_ModHandler.getIC2Item("iridiumShard", 1)									, MT.Ir					,  U / 9);
        OM.data(UT.Stacks.make(Items.book, 1, W)											, MT.Paper				,  U * 3);
        OM.data(UT.Stacks.make(Items.written_book, 1, W)									, MT.Paper				,  U * 3);
        OM.data(UT.Stacks.make(Items.writable_book, 1, W)									, MT.Paper				,  U * 3);
        OM.data(UT.Stacks.make(Items.enchanted_book, 1, W)									, MT.Paper				,  U * 3);
        OM.data(UT.Stacks.make(Items.golden_apple, 1, 1)									, MT.Au					,  OP.blockIngot.mAmount * 8);
        OM.data(UT.Stacks.make(Items.golden_apple, 1, 0)									, MT.Au					,  OP.ingot.mAmount * 8);
        OM.data(UT.Stacks.make(Items.golden_carrot, 1, 0)									, MT.Au					,  OP.nugget.mAmount * 8);
        OM.data(UT.Stacks.make(Items.speckled_melon, 1, 0)									, MT.Au					,  OP.nugget.mAmount * 8);
        OM.data(UT.Stacks.make(Items.minecart, 1, 0)										, MT.TECH.AnyIron		,  U * 5);
        OM.data(UT.Stacks.make(Items.iron_door, 1, W)										, MT.TECH.AnyIron		,  U * 6);
        OM.data(UT.Stacks.make(Items.cauldron, 1, W)										, MT.TECH.AnyIron		,  U * 7);
        OM.data(UT.Stacks.make(Blocks.iron_bars, 1, W)										, MT.TECH.AnyIron		,  3*U/8);
        OM.data(GT_ModHandler.getIC2Item("ironFence", 1)									, MT.TECH.AnyIron		,  U / 2);
        OM.data(GT_ModHandler.getIC2Item("ironFurnace", 1)									, MT.TECH.AnyIron		,  U * 5);
        OM.data(UT.Stacks.make(Blocks.light_weighted_pressure_plate, 1, W)					, MT.Au					,  U * 2);
        OM.data(UT.Stacks.make(Blocks.heavy_weighted_pressure_plate, 1, W)					, MT.TECH.AnyIron		,  U * 2);
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "anvil", 1, 0)							, MT.TECH.AnyIronSteel	,  U *30);
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "anvil", 1, 1)							, MT.TECH.AnyIronSteel	,  U *20);
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "anvil", 1, 2)							, MT.TECH.AnyIronSteel	,  U *10);
        OM.data(UT.Stacks.make(Blocks.anvil, 1, 0)											, MT.TECH.AnyIron		,  U *30);
        OM.data(UT.Stacks.make(Blocks.anvil, 1, 1)											, MT.TECH.AnyIron		,  U *20);
        OM.data(UT.Stacks.make(Blocks.anvil, 1, 2)											, MT.TECH.AnyIron		,  U *10);
        OM.data(UT.Stacks.make(Blocks.hopper, 1, W)											, MT.TECH.AnyIron		,  U * 5 , MT.Wood, U * 8);
        OM.data(UT.Stacks.make(Blocks.tripwire_hook, 1, W)									, MT.TECH.AnyIron		,  OP.ring.mAmount * 2, MT.Wood, U);
        OM.data(UT.Stacks.make(Items.glass_bottle, 1, W)									, MT.Glass				,  U    );
        OM.data(UT.Stacks.make(Items.potionitem, 1, W)										, MT.Glass				,  U    );
        OM.data(UT.Stacks.make(Blocks.stained_glass			, 1, W)							, MT.Glass				,  U    );
        OM.data(UT.Stacks.make(Blocks.glass					, 1, W)							, MT.Glass				,  U    );
        OM.data(UT.Stacks.make(Blocks.stained_glass_pane	, 1, W)							, MT.Glass				,  3*U/8);
        OM.data(UT.Stacks.make(Blocks.glass_pane			, 1, W)							, MT.Glass				,  3*U/8);
        OM.data(UT.Stacks.make(Items.clock, 1, W)											, MT.Au					,  U * 4, MT.Redstone, U);
        OM.data(UT.Stacks.make(Items.compass, 1, W)											, MT.TECH.AnyIron		,  U * 4, MT.Redstone, U);
        OM.dat2(UT.Stacks.make(Items.saddle, 1, W)											, MT.TECH.AnySteel		,  U * 2, MT.UNUSED.Leather, U * 6);
        OM.dat2(UT.Stacks.make(Items.iron_horse_armor, 1, W)								, MT.TECH.AnyIron		,  U * 8, MT.UNUSED.Leather, U * 6);
        OM.dat2(UT.Stacks.make(Items.golden_horse_armor, 1, W)								, MT.Au					,  U * 8, MT.UNUSED.Leather, U * 6);
        OM.dat2(UT.Stacks.make(Items.diamond_horse_armor, 1, W)								, MT.Diamond			,  U * 8, MT.UNUSED.Leather, U * 6);
        OM.data(UT.Stacks.make(Items.leather, 1, W)											, MT.UNUSED.Leather		,  U * 1);
        OM.data(UT.Stacks.make(Blocks.beacon, 1, W)											, MT.NetherStar			,  U * 1, OM.stack(MT.Obsidian, U * 3), OM.stack(MT.Glass, U * 5));
        OM.data(UT.Stacks.make(Blocks.enchanting_table, 1, W)								, MT.Diamond			,  U * 2, OM.stack(MT.Obsidian, U * 4), OM.stack(MT.Paper, U * 3));
        OM.data(UT.Stacks.make(Blocks.ender_chest, 1, W)									, MT.EnderEye			,  U * 1, MT.Obsidian, U * 8);
        OM.data(UT.Stacks.make(Blocks.bookshelf, 1, W)										, MT.Paper				,  U * 9, MT.Wood, U * 6);
        OM.data(UT.Stacks.make(Blocks.lever, 1, W)											, MT.Stone				,  U * 1, MT.Wood, U / 2);
        OM.data(UT.Stacks.make(Blocks.ice, 1, W)											, MT.Ice				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.packed_ice, 1, W)										, MT.Ice				,  U * 2);
        OM.data(UT.Stacks.make(Blocks.snow, 1, W)											, MT.Snow				,  U * 1);
        OM.data(UT.Stacks.make(Items.snowball, 1, W)										, MT.Snow				,  U / 4);
        OM.data(UT.Stacks.make(Blocks.snow_layer, 1, W)										, MT.Snow				,     -1);
        OM.data(UT.Stacks.make(Blocks.sand, 1, 0)											, MT.Sand				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.sand, 1, 1)											, MT.Sand				,  3*U/4, MT.TECH.AnyIron, U / 4);
        OM.data(UT.Stacks.make(Blocks.sandstone, 1, W)										, MT.Sand				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1, 0)										, MT.Stone				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1, 8)										, MT.Stone				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1, 0)								, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1, 8)								, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1, 1)										, MT.Sand				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1, 9)										, MT.Sand				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1, 1)								, MT.Sand				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1, 9)								, MT.Sand				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1,  2)									, MT.Wood				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1, 10)									, MT.Wood				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1,  2)								, MT.Wood				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1, 10)								, MT.Wood				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1,  3)									, MT.Stone				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1, 11)									, MT.Stone				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1,  3)								, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1, 11)								, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1,  5)									, MT.Stone				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.stone_slab, 1, 13)									, MT.Stone				,  U / 2);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1,  5)								, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.double_stone_slab, 1, 13)								, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone, 1, W)											, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.furnace, 1, W)										, MT.Stone				,  U * 8);
        OM.data(UT.Stacks.make(Blocks.lit_furnace, 1, W)									, MT.Stone				,  U * 8);
        OM.data(UT.Stacks.make(Blocks.stonebrick, 1, W)										, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.cobblestone, 1, W)									, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.mossy_cobblestone, 1, W)								, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone_button, 1, W)									, MT.Stone				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.stone_pressure_plate, 1, W)							, MT.Stone				,  U * 2);
        OM.data(UT.Stacks.make(Blocks.ladder, 1, W)											, MT.Wood				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.wooden_button, 1, W)									, MT.Wood				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.wooden_pressure_plate, 1, W)							, MT.Wood				,  U * 2);
        OM.data(UT.Stacks.make(Blocks.fence, 1, W)											, MT.Wood				,  3*U/2);
        OM.data(UT.Stacks.make(Items.bowl, 1, W)											, MT.Wood				,  U * 1);
        OM.data(UT.Stacks.make(Items.sign, 1, W)											, MT.Wood				,  U * 2);
        OM.data(UT.Stacks.make(Items.wooden_door, 1, W)										, MT.Wood				,  U * 6);
        OM.data(UT.Stacks.make(Blocks.chest, 1, W)											, MT.Wood				,  U * 8);
        OM.data(UT.Stacks.make(Blocks.trapped_chest, 1, W)									, MT.Wood				,  U * 9, MT.TECH.AnyIron, OP.ring.mAmount * 2);
        OM.data(UT.Stacks.make(Blocks.unlit_redstone_torch, 1, W)							, MT.Wood				,  U / 2, MT.Redstone, U);
        OM.data(UT.Stacks.make(Blocks.redstone_torch, 1, W)									, MT.Wood				,  U / 2, MT.Redstone, U);
        OM.data(UT.Stacks.make(Blocks.noteblock, 1, W)										, MT.Wood				,  U * 8, MT.Redstone, U);
        OM.data(UT.Stacks.make(Blocks.jukebox, 1, W)										, MT.Wood				,  U * 8, MT.Diamond, U);
        OM.data(UT.Stacks.make(Blocks.crafting_table, 1, W)									, MT.Wood				,  U * 4);
        OM.data(GT_ModHandler.getIC2Item("crop", 1)											, MT.Wood				,  U * 1);
        OM.data(UT.Stacks.make(Blocks.piston, 1, W)											, MT.Stone				,  U * 4, MT.Wood, U * 3);
        OM.data(UT.Stacks.make(Blocks.sticky_piston, 1, W)									, MT.Stone				,  U * 4, MT.Wood, U * 3);
        OM.data(UT.Stacks.make(Blocks.dispenser, 1, W)										, MT.Stone				,  U * 7, MT.Redstone, U);
        OM.data(UT.Stacks.make(Blocks.dropper, 1, W)										, MT.Stone				,  U * 7, MT.Redstone, U);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 0)			, MT.Au					,  U    );
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 1)			, MT.Au					,  4*U/9);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 2)			, MT.Au					,  U    , MT.UNUSED.Leather, U * 3);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 3)			, MT.Au					,  4*U/9, MT.InfusedAir		, U / 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 4)			, MT.Au					,  4*U/9, MT.InfusedEarth		, U / 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 5)			, MT.Au					,  4*U/9, MT.InfusedFire		, U / 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 6)			, MT.Au					,  4*U/9, MT.InfusedWater		, U / 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 7)			, MT.Au					,  4*U/9, MT.InfusedOrder		, U / 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemBaubleBlanks"		, 1, 8)			, MT.Au					,  4*U/9, MT.InfusedEntropy	, U / 4);
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetChicken"		, 1, W)			, MT.MeatCooked			,  U / 9);
    	OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetBeef"		, 1, W)			, MT.MeatCooked			,  U / 9);
    	OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetPork"		, 1, W)			, MT.MeatCooked			,  U / 9);
    	OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetFish"		, 1, W)			, MT.MeatCooked			,  U / 9);
	}
}