package gregapi.render;

import static gregapi.data.CS.*;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.IBlockAccess;
import net.minecraftforge.client.IItemRenderer;

import org.lwjgl.opengl.GL11;

import cpw.mods.fml.client.registry.ISimpleBlockRenderingHandler;

/**
 * @author Gregorius Techneticies
 */
public class RendererBlockTextured implements ISimpleBlockRenderingHandler, IItemRenderer {
	public final int mRenderID;
	public static RendererBlockTextured INSTANCE;
	public static NBTTagCompound mUsedNBT = null;
	
	public RendererBlockTextured(int aRenderID) {
		INSTANCE = this;
		mRenderID = aRenderID;
	}
	
    @Override
	public void renderInventoryBlock(Block aBlock, int aMetaData, int aModelID, RenderBlocks aRenderer) {
		aRenderer.setRenderBoundsFromBlock(aBlock);
		
		ItemStack aStack = UT.Stacks.make(aBlock, 1, aMetaData, mUsedNBT);
		
		ITexture.Util.startRendering(aRenderer, aBlock, null, 0, 0, 0);
		
    	if (aBlock instanceof IRenderedBlock) {
        	GL11.glRotatef(90, 0, 1, 0);
        	GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
			boolean tNeedsToSetBounds = T;
    		IRenderedBlockObject tRenderer = ((IRenderedBlock)aBlock).passRenderingToObject(aStack);
    		if (tRenderer != null) tRenderer = tRenderer.passRenderingToObject(aStack);
    		if (tRenderer == null) {
	        	for (int i = 0, j = ((IRenderedBlock)aBlock).getRenderPasses(aStack); i < j; i++) {
	        		if (((IRenderedBlock)aBlock).usesRenderPass(i, aStack)) {
		        		Tessellator.instance.startDrawingQuads();
		        		if (((IRenderedBlock)aBlock).setBlockBounds(i, aStack)) {tNeedsToSetBounds = T; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = F;}
		            	Tessellator.instance.setNormal( 0, -1,  0); renderNegativeYFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_NEG, aStack), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 0,  1,  0); renderPositiveYFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_POS, aStack), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 0,  0, -1); renderNegativeZFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_NEG, aStack), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 0,  0,  1); renderPositiveZFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_POS, aStack), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal(-1,  0,  0); renderNegativeXFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_NEG, aStack), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 1,  0,  0); renderPositiveXFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_POS, aStack), !tNeedsToSetBounds);
		            	Tessellator.instance.draw();
	        		}
	        	}
    		} else {
    			if (!tRenderer.renderItem(aBlock, aRenderer)) for (int i = 0, j = tRenderer.getRenderPasses(aBlock); i < j; i++) {
	        		if (tRenderer.usesRenderPass(i)) {
		        		Tessellator.instance.startDrawingQuads();
		        		if (tRenderer.setBlockBounds(aBlock, i)) {tNeedsToSetBounds = T; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = F;}
		            	Tessellator.instance.setNormal( 0, -1,  0); renderNegativeYFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Y_NEG), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 0,  1,  0); renderPositiveYFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Y_POS), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 0,  0, -1); renderNegativeZFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Z_NEG), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 0,  0,  1); renderPositiveZFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Z_POS), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal(-1,  0,  0); renderNegativeXFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_X_NEG), !tNeedsToSetBounds);
		            	Tessellator.instance.setNormal( 1,  0,  0); renderPositiveXFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_X_POS), !tNeedsToSetBounds);
		            	Tessellator.instance.draw();
	        		}
	        	}
    		}
			if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    	}
		aRenderer.setRenderBoundsFromBlock(aBlock);
    	GL11.glTranslatef(0.5F, 0.5F, 0.5F);
    	
		ITexture.Util.endRendering(aRenderer, aBlock, null, 0, 0, 0);
    }
    
    @Override
	public boolean renderWorldBlock(IBlockAccess aWorld, int aX, int aY, int aZ, Block aBlock, int aModelID, RenderBlocks aRenderer) {
        Tessellator.instance.setBrightness(983055);
		boolean rReturn = F;
		aRenderer.setRenderBoundsFromBlock(aBlock);
		
		ITexture.Util.startRendering(aRenderer, aBlock, aWorld, aX, aY, aZ);
		
    	if (aBlock instanceof IRenderedBlock) {
    		IRenderedBlockObject tRenderer = ((IRenderedBlock)aBlock).passRenderingToObject(aWorld, aX, aY, aZ);
    		if (tRenderer != null) tRenderer = tRenderer.passRenderingToObject(aWorld, aX, aY, aZ);
    		if (tRenderer == null) {
    			boolean tNeedsToSetBounds = T;
    			for (int i = 0, j = ((IRenderedBlock)aBlock).getRenderPasses(aWorld, aX, aY, aZ); i < j; i++) {
	        		if (((IRenderedBlock)aBlock).usesRenderPass(i, aWorld, aX, aY, aZ)) {
	    				if (((IRenderedBlock)aBlock).setBlockBounds(i, aWorld, aX, aY, aZ)) {tNeedsToSetBounds = T; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = F;}
	    				if (renderNegativeYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_NEG, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = T;
	                	if (renderPositiveYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_POS, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = T;
	                	if (renderNegativeZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_NEG, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = T;
	                	if (renderPositiveZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_POS, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = T;
	                	if (renderNegativeXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_NEG, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = T;
	                	if (renderPositiveXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_POS, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = T;
	    			}
	        	}
				if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    		} else {
    			if (tRenderer.renderBlock(aBlock, aRenderer)) {
    				rReturn = T;
    			} else {
        			boolean tNeedsToSetBounds = T;
    				for (int i = 0, j = tRenderer.getRenderPasses(aBlock); i < j; i++) {
    	        		if (tRenderer.usesRenderPass(i)) {
		    				if (tRenderer.setBlockBounds(aBlock, i)) {tNeedsToSetBounds = T; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = F;}
		                	if (renderNegativeYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Y_NEG), !tNeedsToSetBounds)) rReturn = T;
		                	if (renderPositiveYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Y_POS), !tNeedsToSetBounds)) rReturn = T;
		                	if (renderNegativeZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Z_NEG), !tNeedsToSetBounds)) rReturn = T;
		                	if (renderPositiveZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Z_POS), !tNeedsToSetBounds)) rReturn = T;
		                	if (renderNegativeXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_X_NEG), !tNeedsToSetBounds)) rReturn = T;
		                	if (renderPositiveXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_X_POS), !tNeedsToSetBounds)) rReturn = T;
    	        		}
    	        	}
    				if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    			}
    		}
    	}
		aRenderer.setRenderBoundsFromBlock(aBlock);
		
		ITexture.Util.endRendering(aRenderer, aBlock, aWorld, aX, aY, aZ);
		
    	return rReturn;
    }
    
    public static boolean renderNegativeYFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	if (aIcon == null || !aIcon.isValidTexture()) return F;
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY-1, aZ, 0)) return F;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aFullBlock?aY-1:aY, aZ);
	        aRenderer.enableAO = T;
    	}
    	aIcon.renderYNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness, !aFullBlock);
    	aRenderer.flipTexture = F;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.5F;
		return T;
    }
    
    public static boolean renderPositiveYFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	if (aIcon == null || !aIcon.isValidTexture()) return F;
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY+1, aZ, 1)) return F;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aFullBlock?aY+1:aY, aZ);
	        aRenderer.enableAO = T;
    	}
		aIcon.renderYPos(aRenderer, aBlock, aX, aY, aZ, aBrightness, !aFullBlock);
    	aRenderer.flipTexture = F;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 1.0F;
		return T;
	}
    
    public static boolean renderNegativeZFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	if (aIcon == null || !aIcon.isValidTexture()) return F;
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY, aZ-1, 2)) return F;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aY, aFullBlock?aZ-1:aZ);
	        aRenderer.enableAO = T;
    	}
		aRenderer.flipTexture = !aFullBlock;
    	aIcon.renderZNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness, !aFullBlock);
		aRenderer.flipTexture = F;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.8F;
		return T;
    }
    
    public static boolean renderPositiveZFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	if (aIcon == null || !aIcon.isValidTexture()) return F;
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY, aZ+1, 3)) return F;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aY, aFullBlock?aZ+1:aZ);
	        aRenderer.enableAO = T;
    	}
    	aIcon.renderZPos(aRenderer, aBlock, aX, aY, aZ, aBrightness, !aFullBlock);
    	aRenderer.flipTexture = F;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.8F;
		return T;
    }
    
    public static boolean renderNegativeXFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	if (aIcon == null || !aIcon.isValidTexture()) return F;
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX-1, aY, aZ, 4)) return F;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aFullBlock?aX-1:aX, aY, aZ);
	        aRenderer.enableAO = T;
    	}
    	aIcon.renderXNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness, !aFullBlock);
    	aRenderer.flipTexture = F;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.6F;
		return T;
    }
    
    public static boolean renderPositiveXFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	if (aIcon == null || !aIcon.isValidTexture()) return F;
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX+1, aY, aZ, 5)) return F;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aFullBlock?aX+1:aX, aY, aZ);
	        aRenderer.enableAO = T;
    	}
		aRenderer.flipTexture = !aFullBlock;
    	aIcon.renderXPos(aRenderer, aBlock, aX, aY, aZ, aBrightness, !aFullBlock);
		aRenderer.flipTexture = F;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.6F;
		return T;
    }
    
    @Override
	public boolean shouldRender3DInInventory(int aModel) {
        return T;
    }
    
    @Override
	public int getRenderId() {
        return mRenderID;
    }
    
	@Override
	public boolean handleRenderType(ItemStack aStack, ItemRenderType aType) {
		mUsedNBT = aStack.getTagCompound();
		return F;
	}
	
	@Override
	public boolean shouldUseRenderHelper(ItemRenderType aType, ItemStack aStack, ItemRendererHelper aHelper) {
		mUsedNBT = aStack.getTagCompound();
		return F;
	}
	
	@Override
	public void renderItem(ItemRenderType aType, ItemStack aStack, Object... data) {
		mUsedNBT = aStack.getTagCompound();
	}
}